



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>理解C# 4 dynamic(2) – ExpandoObject的使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">理解C# 4 dynamic(2) – ExpandoObject的使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 22:04:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>ExpandoObject的使用非常简单，很容易入手。上一篇里面已经有详细的介绍了，可以看这里<br /><a href="http://www.cnblogs.com/JustRun1983/p/3163350.html" rel="external nofollow noreferrer">(理解C# 4 dynamic(1) - var, object, dynamic的区别以及dynamic的使用)</a>下面对ExpandoObject的使用场合和一些认为需要注意的地方，谈一下自己的看法:</p>
<h1><strong>一，ExpandoObject使用场合</strong></h1>
<p>在传递对象，但是又不想创建一个class或者struct的时候，ExpandoObject就是一个非常好的选择。<br />假如我们有一个SendMail的函数，功能是发送一个通知邮件给客户，邮件的文本模板，如下:<br />Dear [Name],<br />We have sent the gift to your address: [Address]</p>
<p>在具体发送邮件的时候， [Name]和[Address]的内容是从函数GetMailParameters()动态读取出来的。<br />那么函数GetMailParameters的返回值如何定义好呢?</p>
<p>如果为GetMailParameters()函数创建一个struct或者class来传递, 有些小题大做了，而且定义的struct和class重用性会非常低。</p>
<p>如果使用了ExpandoObject, 就非常容易的解决了这个问题。</p>
<div>
<pre class="prettyprint linenums">public dynamic GetMailParameters()<br />
{<br />
     var mailParameters = new ExpandoObject();<br />
     mailParameters.Name=&rdquo;Peter&rdquo;;<br />
     mailParameters.Address=&rdquo;Shanghai China&rdquo;<br />
     return mail;<br />
}</pre>
</div>
<p>就算以后邮件模板改变，添加了新的变量，也只是简单的在ExpandoObject上扩展一个属性就可以了。</p>
<h1><strong>二, 注意问题</strong></h1>
<p>由于ExpandObject的先天不足(无特征性):</p>
<p><strong>1. 没有区分的类型名称<br />2. 没有确切类型定义</strong></p>
<p>如果你看到一个string的函数返回值, 你会想到什么, 你会知道它是一个字符串(这不是废话吗?)， 有Length等属性，有IndexOf等方法。<br />当返回值是MailHelper类对象时，你想只需要直接F12就能看到源码，里面有关于这个类的详细定义，接着你就知道如何使用这个对象了。</p>
<p>当你从一个函数中得到一个ExpandObject的dynamic的返回值时，你知道是什么吗? ExpandObject就是一个黑箱，里面装着什么，谁都不知道。<br />所以，</p>
<p><strong>1. ExpandObject不能用于太复杂的对象。</strong></p>
<p>ExpandObject最好还是作为简单的数据容器，不要弄得过于复杂，甚至包含有函数处理。</p>
<p><strong>2.ExpandObject的使用范围必须要短</strong></p>
<p>范围短的意思是，产生和使用ExpandObject的代码的路径必须要短(主要是函数调用路径)。如果你正在使用一个ExpandObject对象，查看产生这个ExpandObject的地方，发现分散在好几个函数之中，还有嵌套的话，那么这个ExpandObject是非常难于维护的。</p>
<p><strong>3. ExpandObject的使用场合最好贴近程序的终端。</strong></p>
<p>比如在MVC中的ViewBag, 就是一个好的例子。ViawBag用于生成页面, 而页面就是MVC程序的终端了。到了终端，ExpandObject也就不能祸害它人了。<br />正是由于ExpandObject的无特征性，什么都可以做，所以容易导致滥用。</p>
<p>下篇介绍如何通过继承DynamicObject和实现IDynamicMetaObjectProvider，为动态类型添加特征性。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvk5y9x.html">&lbrack;转&rsqb;Java常用工具类集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kgw139.html">makefile自动生成依赖关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xp4068.html">laravel下的团队开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0n3yeq.html">PageValidate 类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1wwv38.html">MapReducer Counter计数器的使用&comma;Combiner &comma;Partitioner&comma;Sort&comma;Grop的使用&comma;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1k5mj8.html">javaIo流实际应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1p3539.html">js移除最后一个字符，js替换字符串的连接符号，js移除最后一个分隔符号</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okpmzx9.html">vim设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1wmrj9.html">sublime text 2 安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4znkpe9.html">Json数据解析在Unity3d中的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mex34oq.html">docker：（5）利用docker -v 和 Publish over SSH插件实现war包自动部署到docker</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoxx1vq.html">RSync实现文件备份同步，rsync服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd57kd9.html">Python3 字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1j3le9.html">How to convert Word table into Excel using OpenXML</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll1wrkq.html">&lbrack;Hive&lowbar;10&rsqb; Hive 的分析函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jkyw5q.html">Java高级面试题解析（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j7yo0q.html">Web版记账本开发记录（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjwo779.html">一次单片机 SFR 页引发的&OpenCurlyDoubleQuote;事故&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j0r3jq.html">混合pyqt和qtcreator</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjo2p49.html">scrapy中deferred的回调</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r8mjld08.html">Android  第一http请求访问慢，以后就快了的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zkrrx8.html">SVN 提交代码时提示文件已经存在解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jmnv09.html">android去掉滑动到顶部和底部的阴影</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rnye4q.html">学习 AppFuse</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o45k5q.html">zDiaLog弹出层</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqve0jz9.html">基于nutz框架理解Ioc容器</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwlrll9.html">ORA-00600&colon; internal error code&comma; arguments&colon; &lbrack;17281&rsqb;&comma; &lbrack;1001&rsqb;&comma; &lbrack;0x1FF863EE8&rsqb;&comma; &lbrack;&rsqb;&comma; &lbrack;&rsqb;&comma; &lbrack;&rsqb;&comma; &lbrack;&rsqb;&comma; &lbrack;&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/4953zxm8.html">Mysql有用的面试题</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql1wm09.html">Mysql小技巧总汇</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwln739.html">Linux shell 通配符 &sol; glob 模式</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
